from ._utils.windows import get_syspaths_from_registry as get_syspaths_from_registry, to_windows_path as to_windows_path
from _typeshed import Incomplete
from rez.shells import Shell
from typing import Any

class CMD(Shell):
    syspaths: Incomplete
    _doskey: Incomplete
    expand_env_vars: bool
    _env_var_regex: Incomplete
    _escape_re: Incomplete
    _escaper: Incomplete
    _doskey_aliases: dict[Any, Any]
    def __init__(self) -> None: ...
    @classmethod
    def name(cls) -> str: ...
    @classmethod
    def file_extension(cls) -> str: ...
    @classmethod
    def startup_capabilities(cls, rcfile: bool = False, norc: bool = False, stdin: bool = False, command: bool = False): ...
    @classmethod
    def get_startup_sequence(cls, rcfile, norc, stdin, command): ...
    @classmethod
    def get_syspaths(cls): ...
    def _bind_interactive_rez(self) -> None: ...
    def spawn_shell(self, context_file, tmpdir, rcfile: Incomplete | None = None, norc: bool = False, stdin: bool = False, command: Incomplete | None = None, env: Incomplete | None = None, quiet: bool = False, pre_command: Incomplete | None = None, add_rez: bool = True, **Popen_args): ...
    def get_output(self, style=...): ...
    def escape_string(self, value: str, is_path: bool = False) -> str:
        """Escape the <, >, ^, and & special characters reserved by Windows.

        Args:
            value (str/EscapedString): String or already escaped string.

        Returns:
            str: The value escaped for Windows.

        """
    def normalize_path(self, path): ...
    def _saferefenv(self, key) -> None: ...
    def shebang(self) -> None: ...
    def setenv(self, key, value) -> None: ...
    def unsetenv(self, key) -> None: ...
    def resetenv(self, key, value, friends: Incomplete | None = None) -> None: ...
    def alias(self, key, value) -> None: ...
    def comment(self, value) -> None: ...
    def info(self, value) -> None: ...
    def error(self, value) -> None: ...
    def source(self, value) -> None: ...
    def command(self, value) -> None: ...
    @classmethod
    def get_all_key_tokens(cls, key): ...
    @classmethod
    def join(cls, command): ...
    @classmethod
    def line_terminator(cls) -> str: ...
    def _expand_alias(self, command):
        """Expand `command` if alias is being presented

        This is important for Windows CMD shell because the doskey.exe isn't
        executed yet when the alias is being passed in `command`. This means we
        cannot rely on doskey.exe to execute alias in first run. So here we
        lookup alias that were just parsed from package, replace it with full
        command if matched.
        """

def register_plugin(): ...
